
C
C This program demonstrates the effect of unnecessary synchronization
C even with correct (in the buffering sense) programs
C The output is best understood from the upshot output
C
	program main
	include 'mpif.h'

	integer nr, nc, maxlen, len
	parameter (maxlen=2048)
C       Neighbors	
	integer left, right, up, down
C       My coordinates
	integer rank, row, col
	integer size, i, j, loop
	double precision edgein(maxlen,4), edgeout(maxlen,4)
	integer req(4), statuses(MPI_STATUS_SIZE, 4)
	integer ierr

	call MPI_INIT( ierr )

C       Set mesh sizes
	nr  = 4
	nc  = 3
C       len must be no larger than maxlen
	len = 2048
C	
C We could use the topology functions, but to maintain exact 
C control, we setup the mesh by hand
C
	call MPI_Comm_rank( MPI_COMM_WORLD, rank, ierr )
	call MPI_Comm_size( MPI_COMM_WORLD, size, ierr )
	if (size .lt. nr * nc) then
	   print *, 'Size of MPI_COMM_WORLD is too small'
	   call MPI_Abort( MPI_COMM_WORLD, 1, ierr )
	   stop
	endif
C    
	row = mod( rank, nr )
	col = rank / nr
C
	left  = MPI_PROC_NULL
	right = MPI_PROC_NULL
	up    = MPI_PROC_NULL
	down  = MPI_PROC_NULL
	if (row .gt. 0) up = row - 1 + col * nr;
	if (col .gt. 0) left = row + (col - 1) * nr;
	if (row .lt. nr - 1) down = row + 1 + col * nr;
	if (col .lt. nc - 1) right = row + (col + 1) * nr;
C
C initialize the data areas
    
	do j=1, 4
	   do i=1, len
	      edgein(i,j) = -1.0
	      edgeout(i,j) = 1.0
	      enddo
	   enddo
C	   
C Run twice to reduce paging effects
	do loop=1, 2
	   call MPI_Barrier( MPI_COMM_WORLD, ierr )
	   call MPI_Irecv( edgein(1,1), len, MPI_DOUBLE_PRECISION, 
     1                     up, 0, MPI_COMM_WORLD, req(1), ierr )
	   call MPI_Irecv( edgein(1,2), len, MPI_DOUBLE_PRECISION, 
     1                     left, 1, MPI_COMM_WORLD, req(2), ierr )
	   call MPI_Irecv( edgein(1,3), len, MPI_DOUBLE_PRECISION, 
     1            down, 2, MPI_COMM_WORLD, req(3), ierr )
	   call MPI_Irecv( edgein(1,4), len, MPI_DOUBLE_PRECISION, 
     1            right, 3, MPI_COMM_WORLD, req(4), ierr )
C	
	   call MPI_Send( edgeout(1,1), len, MPI_DOUBLE_PRECISION, 
     1                    down, 0, MPI_COMM_WORLD, ierr )
	   call MPI_Send( edgeout(1,2), len, MPI_DOUBLE_PRECISION, 
     1                    right, 1, MPI_COMM_WORLD, ierr )
	   call MPI_Send( edgeout(1,3), len, MPI_DOUBLE_PRECISION, 
     1                    up, 2, MPI_COMM_WORLD, ierr )
	   call MPI_Send( edgeout(1,4), len, MPI_DOUBLE_PRECISION, 
     1                    left, 3, MPI_COMM_WORLD, ierr )
C	
	   call MPI_Waitall( 4, req, statuses, ierr )
	enddo

	call MPI_Finalize( ierr )
C
	end
